<?php

class Fix
{
    var $_args; // is_array
    
    public function __construct($args = array())
    {
        $this->_args   = $args;
    }
}

class Fix_BlogAlign extends Fix
{
    function execute()
    {
        @set_time_limit(0);
        $DB = DB::singleton(SetupCommon::dsn());

        $que    = array(0);    // FIFO
        $aryPid = array();
        while ( true ) {
            $pid    = array_shift($que);

            $pos    = 0;
            if ( !empty($pid) ) {
                $SQL    = SQL::newSelect('blog');
                $SQL->addWhereOpr('blog_id', $pid);
                if ( !!($row = $DB->query($SQL->get(SetupCommon::dsn()), 'row')) ) {
                    $pos    = intval($row['blog_left']);// - 1;
                } else {
                    continue;
                }
            }

            $SQL    = SQL::newSelect('blog');
            $SQL->setSelect('blog_id');
            $SQL->addWhereOpr('blog_parent', $pid);
            $SQL->setOrder('blog_sort');

            $cnt    = 0;
            if ( !!($all = $DB->query($SQL->get(SetupCommon::dsn()), 'all')) ) {

                foreach ( $DB->query($SQL->get(SetupCommon::dsn()), 'all') as $row ) {
                    $cnt++;
                    $bid    = intval($row['blog_id']);
                    $right  = ($cnt*2) + $pos;
                    $left   = $right - 1;

                    $SQL    = SQL::newUpdate('blog');
                    $SQL->addUpdate('blog_left', $left);
                    $SQL->addUpdate('blog_right', $right);
                    $SQL->addUpdate('blog_sort', $cnt);
                    $SQL->addWhereOpr('blog_id', $bid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

                    array_push($que, $bid);
                }

                if ( !empty($aryPid) ) {
                    $SQL    = SQL::newUpdate('blog');
                    $SQL->setUpdate('blog_left', SQL::newOpr('blog_left', ($cnt * 2), '+'));
                    $SQL->addWhereOpr('blog_left', $pos, '>');
                    $SQL->addWhereIn('blog_parent', $aryPid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

                    $SQL    = SQL::newUpdate('blog');
                    $SQL->setUpdate('blog_right', SQL::newOpr('blog_right', ($cnt * 2), '+'));
                    $SQL->addWhereOpr('blog_right', $pos, '>=');
                    $SQL->addWhereIn('blog_parent', $aryPid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');
                }
                array_push($aryPid, $pid);
            }

            if ( empty($que) ) break;
        }

        return true;
    }
}

class Fix_BlogDelete extends Fix
{
    function execute($Post)
    {
        do {
            $selected   = $this->_args['selected'];
            $count      = $this->_args['count'];

            if ( 0
                //or 0 === $Post->get('parent_'.$i)
                or 1 > $selected
                or $count < $selected
            ) {
                //$Post->setMethod('delete', 'operable', false);
                return false;
                break;
            }

            $DB     = DB::singleton(SetupCommon::dsn());
            for ( $i=1; $i<=$count; $i++ ) {
                if ( $selected === $i ) continue;

                $SQL    = SQL::newSelect('blog');
                $SQL->setSelect('blog_id', 'blog_amount', null, 'count');
                $SQL->addWhereOpr('blog_id', intval($Post->get('bid_'.$i)));
                $SQL->addWhereOpr('blog_code', strval($Post->get('code_'.$i)));
                $SQL->addWhereOpr('blog_status', strval($Post->get('status_'.$i)));
                $SQL->addWhereOpr('blog_parent', intval($Post->get('parent_'.$i)));
                $SQL->addWhereOpr('blog_sort', intval($Post->get('sort_'.$i)));
                $SQL->addWhereOpr('blog_left', intval($Post->get('left_'.$i)));
                $SQL->addWhereOpr('blog_right', intval($Post->get('right_'.$i)));
                $SQL->addWhereOpr('blog_name', strval($Post->get('name_'.$i)));
                $SQL->addWhereOpr('blog_domain', strval($Post->get('domain_'.$i)));
                $SQL->addWhereOpr('blog_indexing', strval($Post->get('indexing_'.$i)));
                $SQL->setGroup('blog_id');

                if ( 2 <= $DB->query($SQL->get(SetupCommon::dsn()), 'one') ) {
                    $this->Post->setMethod('delete', 'double', false);
                    break 2;
                }

                $SQL    = SQL::newDelete('blog');
                $SQL->addWhereOpr('blog_id', intval($Post->get('bid_'.$i)));
                $SQL->addWhereOpr('blog_code', strval($Post->get('code_'.$i)));
                $SQL->addWhereOpr('blog_status', strval($Post->get('status_'.$i)));
                $SQL->addWhereOpr('blog_parent', intval($Post->get('parent_'.$i)));
                $SQL->addWhereOpr('blog_sort', intval($Post->get('sort_'.$i)));
                $SQL->addWhereOpr('blog_left', intval($Post->get('left_'.$i)));
                $SQL->addWhereOpr('blog_right', intval($Post->get('right_'.$i)));
                $SQL->addWhereOpr('blog_name', strval($Post->get('name_'.$i)));
                $SQL->addWhereOpr('blog_domain', strval($Post->get('domain_'.$i)));
                $SQL->addWhereOpr('blog_indexing', strval($Post->get('indexing_'.$i)));
                $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

            }

        } while ( false );

        return true;
    }
}

class Fix_CategoryAlign extends Fix
{
    function execute()
    {
        $bid    = $this->_args['bid'];

        @set_time_limit(0);
        $DB = DB::singleton(SetupCommon::dsn());

        $que    = array(0); // FIFO
        $aryPid = array();
        while ( true ) {
            $pid    = array_shift($que);

            $pos    = 0;
            if ( !empty($pid) ) {
                $SQL    = SQL::newSelect('category');
                $SQL->addWhereOpr('category_id', $pid);
                $SQL->addWhereOpr('category_blog_id', $bid);
                if ( !!($row = $DB->query($SQL->get(SetupCommon::dsn()), 'row')) ) {
                    $pos    = intval($row['category_left']);// - 1;
                } else {
                    continue;
                }
            }

            $SQL    = SQL::newSelect('category');
            $SQL->setSelect('category_id');
            $SQL->addWhereOpr('category_parent', $pid);
            $SQL->addWhereOpr('category_blog_id', $bid);
            $SQL->setOrder('category_sort');

            $cnt    = 0;
            if ( !!($all = $DB->query($SQL->get(SetupCommon::dsn()), 'all')) ) {
                foreach ( $all as $row ) {
                    $cnt++;
                    $cid    = intval($row['category_id']);
                    $right  = ($cnt*2) + $pos;
                    $left   = $right - 1;

                    $SQL    = SQL::newUpdate('category');
                    $SQL->addUpdate('category_left', $left);
                    $SQL->addUpdate('category_right', $right);
                    $SQL->addUpdate('category_sort', $cnt);
                    $SQL->addWhereOpr('category_id', $cid);
                    $SQL->addWhereOpr('category_blog_id', $bid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

                    array_push($que, $cid);
                }

                if ( !empty($aryPid) ) {
                    $SQL    = SQL::newUpdate('category');
                    $SQL->setUpdate('category_left', SQL::newOpr('category_left', ($cnt * 2), '+'));
                    $SQL->addWhereOpr('category_left', $pos, '>');
                    $SQL->addWhereIn('category_parent', $aryPid);
                    $SQL->addWhereOpr('category_blog_id', $bid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

                    $SQL    = SQL::newUpdate('category');
                    $SQL->setUpdate('category_right', SQL::newOpr('category_right', ($cnt * 2), '+'));
                    $SQL->addWhereOpr('category_right', $pos, '>=');
                    $SQL->addWhereIn('category_parent', $aryPid);
                    $SQL->addWhereOpr('category_blog_id', $bid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');
                }
                array_push($aryPid, $pid);
            }

            if ( empty($que) ) break;
        }

        return true;
    }
}

class Fix_CommentAlign extends Fix
{
    function execute()
    {
        @set_time_limit(0);

        $bid    = $this->_args['bid'];

        $DB     = DB::singleton(SetupCommon::dsn());
        $SQL    = SQL::newSelect('comment');
        $SQL->setSelect('comment_entry_id', 'eid', '', 'DISTINCT');
        $SQL->addWhereOpr('comment_blog_id', $bid);
        $SQL->setOrder('eid');
        $entryQ = $SQL->get(SetupCommon::dsn());
        if ( $DB->query($entryQ, 'fetch') ) { while ( !!($entryRow = $DB->fetch($entryQ)) ) {
            $eid    = intval($entryRow['eid']);

            $SQL    = SQL::newSelect('comment');
            $SQL->setSelect('comment_parent', 'pid', '', 'DISTINCT');
            $SQL->addWhereOpr('comment_entry_id', $eid);
            $SQL->addWhereOpr('comment_blog_id', $bid);
            $SQL->setOrder('pid');
            $parentQ    = $SQL->get(SetupCommon::dsn());
            $aryPid     = array();

            if ( $DB->query($parentQ, 'fetch') ) { while ( !!($parentRow = $DB->fetch($parentQ)) ) {
                $pid        = intval($parentRow['pid']);

                //-----
                // pos
                $pos    = 0;
                if ( !empty($pid) ) {
                    $SQL    = SQL::newSelect('comment');
                    $SQL->setSelect('comment_right');
                    $SQL->addWhereOpr('comment_id', $pid);
                    $pos    = intval($DB->query($SQL->get(SetupCommon::dsn()), 'one')) - 1;
                }

                $SQL    = SQL::newSelect('comment');
                $SQL->setSelect('comment_id');
                $SQL->addWhereOpr('comment_parent', $pid);
                $SQL->addWhereOpr('comment_entry_id', $eid);
                $SQL->addWhereOpr('comment_blog_id', $bid);
                $cnt    = 0;
                foreach ( $DB->query($SQL->get(SetupCommon::dsn()), 'all') as $row ) {
                    $cnt++;
                    $cmid   = intval($row['comment_id']);

                    $right  = ($cnt*2) + $pos;
                    $left   = $right - 1;

                    $SQL    = SQL::newUpdate('comment');
                    $SQL->addUpdate('comment_left', $left);
                    $SQL->addUpdate('comment_right', $right);
                    $SQL->addWhereOpr('comment_id', $cmid);
                    $SQL->addWhereOpr('comment_entry_id', $eid);
                    $SQL->addWhereOpr('comment_blog_id', $bid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');
                }

                if ( !empty($aryPid) ) {
                    $SQL    = SQL::newUpdate('comment');
                    $SQL->setUpdate('comment_left', SQL::newOpr('comment_left', ($cnt * 2), '+'));
                    $SQL->addWhereOpr('comment_left', $pos, '>');
                    $SQL->addWhereIn('comment_parent', $aryPid);
                    $SQL->addWhereOpr('comment_entry_id', $eid);
                    $SQL->addWhereOpr('comment_blog_id', $bid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

                    $SQL    = SQL::newUpdate('comment');
                    $SQL->setUpdate('comment_right', SQL::newOpr('comment_right', ($cnt * 2), '+'));
                    $SQL->addWhereOpr('comment_right', $pos, '>=');
                    $SQL->addWhereIn('comment_parent', $aryPid);
                    $SQL->addWhereOpr('comment_entry_id', $eid);
                    $SQL->addWhereOpr('comment_blog_id', $bid);
                    $DB->query($SQL->get(SetupCommon::dsn()), 'exec');
                }

                $aryPid[]   = $pid;
            } }
        } }

        return true;
    }
}

class Fix_Fulltext extends Fix
{
    function loadFulltext($type, $id)
    {
        $DB = DB::singleton(SetupCommon::dsn());

        // 基本フィールド
        $base   = array();

        // カスタムフィールド
        $meta   = array();

        $SQL    = SQL::newSelect('field');
        $SQL->addSelect('field_value');
        $SQL->addWhereOpr('field_search', 'on');

        switch ( $type ) {
            case 'blog':
                // $BLOG   = SQL::newSelect('blog');
                // $BLOG->addSelect('blog_name');
                // $BLOG->addSelect('blog_code');
                // $BLOG->addSelect('blog_domain');
                // $BLOG->addWhereOpr('blog_id', $id);
                // $blog   = $DB->query($BLOG->get(SetupCommon::dsn()), 'row');

                // $base[] = $blog['blog_name'];
                // $base[] = $blog['blog_code'];
                // $base[] = $blog['blog_domain'];

                // $SQL->addWhereOpr('field_bid', $id);
                break;
            case 'category':
                $CATEGORY   = SQL::newSelect('category');
                $CATEGORY->addSelect('category_name');
                $CATEGORY->addSelect('category_code');
                $CATEGORY->addWhereOpr('category_id', $id);
                $category   = $DB->query($CATEGORY->get(SetupCommon::dsn()), 'row');

                $base[] = $category['category_name'];
                $base[] = $category['category_code'];

                $SQL->addWhereOpr('field_cid', $id);
                break;
            case 'user':
                $USER   = SQL::newSelect('user');
                $USER->addSelect('user_name');
                $USER->addSelect('user_code');
                $USER->addSelect('user_mail');
                $USER->addSelect('user_mail_mobile');
                $USER->addSelect('user_url');
                $USER->addWhereOpr('user_id', $id);
                $user   = $DB->query($USER->get(SetupCommon::dsn()), 'row');

                $base[] = $user['user_name'];
                $base[] = $user['user_code'];
                $base[] = $user['user_mail'];
                $base[] = $user['user_mail_mobile'];
                $base[] = $user['user_url'];

                $SQL->addWhereOpr('field_uid', $id);
                break;
            default:
                return false;
                break;
        }

        $q      = $SQL->get(SetupCommon::dsn());

        if ( $DB->query($q, 'fetch') and ($row = $DB->fetch($q)) ) { do {
            $meta[] = $row['field_value'];
        } while ( $row = $DB->fetch($q) ); }

        $base   = preg_replace('@\s+@', ' ', strip_tags(implode(' ', $base)));
        $meta   = preg_replace('@\s+@', ' ', strip_tags(implode(' ', $meta)));
        return $base."\x0d\x0a\x0a\x0d".$meta;
    }

    function loadEntryFulltext($eid)
    {
        $DB     = DB::singleton(SetupCommon::dsn());
        $SQL    = SQL::newSelect('column');
        $SQL->addWhereOpr('column_entry_id', $eid);
        $q      = $SQL->get(SetupCommon::dsn());

        $text   = '';
        $meta   = '';
        if ( $DB->query($q, 'fetch') and ($row = $DB->fetch($q)) ) { do {
            if ( $row['column_align'] === 'hidden' ) continue;
            $type   = $row['column_type'];
            if ( 'text' == $type ) {
                $_text  = $row['column_field_1'];
                if ( 'markdown' == $row['column_field_2'] ) {
                    $_text  = Markdown($_text);
                }
                $text   .= $_text.' ';
            } else {
                $meta   .= $row['column_field_1'].' ';
            }
        } while ( $row = $DB->fetch($q) ); }

        $ENTRY = SQL::newSelect('entry');
        $ENTRY->addSelect('entry_title');
        $ENTRY->addWhereOpr('entry_id', $eid);
        $entryTitle = $DB->query($ENTRY->get(SetupCommon::dsn()), 'one');
        $meta   .=  $entryTitle.' ';

        $SQL    = SQL::newSelect('field');
        $SQL->addSelect('field_value');
        $SQL->addWhereOpr('field_search', 'on');
        $SQL->addWhereOpr('field_eid', $eid);
        $q      = $SQL->get(SetupCommon::dsn());

        if ( $DB->query($q, 'fetch') and ($row = $DB->fetch($q)) ) { do {
            $meta   .= $row['field_value'].' ';
        } while ( $row = $DB->fetch($q) ); }

        $text   = str_replace(':acms_unit_text_delimiter:', '', $text);
        return preg_replace('@\s+@', ' ', strip_tags($text))
            ."\x0d\x0a\x0a\x0d".preg_replace('@\s+@', ' ', strip_tags($meta))
        ;
    }

    function saveFulltext($type, $id, $fulltext=null, $bid=1)
    {
        $DB     = DB::singleton(SetupCommon::dsn());
        $SQL    = SQL::newDelete('fulltext');
        $SQL->addWhereOpr('fulltext_'.$type, $id);
        $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

        if ( !empty($fulltext) ) {
            $SQL    = SQL::newInsert('fulltext');
            $SQL->addInsert('fulltext_value', $fulltext);
            $SQL->addInsert('fulltext_'.$type, $id);
            $SQL->addInsert('fulltext_blog_id', $bid);
            $DB->query($SQL->get(SetupCommon::dsn()), 'exec');
        }
        return true;
    }

    function execute()
    {
        @set_time_limit(0);

        $type   = $this->_args['type'];

        if ( !in_array($type, array('blog', 'category', 'user', 'entry')) ) {
            return false;
        }

        $key        = $type.'_id';
        $blog_key   = $type == 'blog' ? 'blog_id' : $type.'_blog_id';
        $type_id    = substr($type, 0, 1).'id';

        $DB     = DB::singleton(SetupCommon::dsn());
        $SQL    = SQL::newSelect($type);
        $SQL->addSelect($key);
        $SQL->addSelect($blog_key);
        $all    = $DB->query($SQL->get(SetupCommon::dsn()), 'all');
        foreach ( $all as $row ) {
            $id     = $row[$key];
            $blogid = $row[$blog_key];
            $fulltext   = '';
            if ( $type == 'entry' ) {
                $fulltext   = $this->loadEntryFulltext($id);
            } else {
                $fulltext   = $this->loadFulltext($type, $id);
            }
            $this->saveFulltext($type_id, $id, $fulltext, $blogid);
        }
        return true;
    }
}

class Fix_Ngram extends Fix
{
    function ngram($txt, $n)
    {
        $aryWord    = array();
        $len        = (mb_strlen($txt, 'UTF-8') - ($n - 1));
        if ( is_string($txt) and $len > 0 ) {
            for ( $i=0; $i<$len; $i++ ) $aryWord[]  = mb_substr($txt, $i, $n, 'UTF-8');
        } else {
            $aryWord[]  = $txt;
        }
        return $aryWord;
    }

    function execute()
    {
        @set_time_limit(0);

        $ngram  = $this->_args['ngram'];

        $DB     = DB::singleton(SetupCommon::dsn());
        $SQL    = SQL::newSelect('entry');
        $SQL->addLeftJoin('fulltext', 'fulltext_eid', 'entry_id');
        $q  = $SQL->get(SetupCommon::dsn());
        $DB->query($q, 'fetch');

        while ( $row = $DB->fetch($q) ) {

            $eid    = intval($row['entry_id']);
            $bid    = intval($row['entry_blog_id']);

            $SQL    = SQL::newSelect('column');
            $SQL->addWhereOpr('column_entry_id', $eid);
            $_all   = $DB->query($SQL->get(SetupCommon::dsn()), 'all');

            $text   = '';
            $meta   = '';
            foreach ( $_all as $_row ) {
                if ( 'text' == $_row['column_type'] ) {
                    $_text  = $_row['column_field_1'];
                    if ( 'markdown' == $_row['column_field_2'] ) {
                        $_text  = Markdown($_text);
                    }
                    $text   .= $_text.' ';
                } else {
                    $meta   .= $_row['column_field_1'].' ';
                }
            }
            $meta   .= $row['entry_title'].' ';

            //--------------------------------
            // field expect fix markdown, tag
            $SQL    = SQL::newSelect('field');
            $SQL->setSelect('field_value');
            $SQL->addWhereOpr('field_search', 'on');
            $SQL->addWhereOpr('field_eid', $eid);
            $SQL->addWhereOpr('field_blog_id', $bid);
            $fQ = $SQL->get(SetupCommon::dsn());
            if ( $DB->query($fQ, 'fetch') ) { while ( $fRow = $DB->fetch($fQ) ) {
                $meta   .= $fRow['field_value'].' ';
            } }

            $SQL    = SQL::newDelete('fulltext');
            $SQL->addWhereOpr('fulltext_eid', $eid);
            $SQL->addWhereOpr('fulltext_blog_id', $bid);
            $DB->query($SQL->get(SetupCommon::dsn()), 'exec');

            $SQL    = SQL::newInsert('fulltext');
            $SQL->addInsert('fulltext_value', 
                preg_replace('@\s+@', ' ', strip_tags($text)).
                "\r\n\r\n".preg_replace('@\s+@', ' ', strip_tags($meta))
            );
            if ( $ngram ) {
                $SQL->addInsert('fulltext_ngram', 
                    preg_replace('@(　|\s)+@', ' ', join(' ', $this->ngram(strip_tags($text.' '.$meta), $ngram)))
                );
            }
            $SQL->addInsert('fulltext_eid', $eid);
            $SQL->addInsert('fulltext_blog_id', $bid);
            $DB->query($SQL->get(SetupCommon::dsn()), 'exec');
        }

        return true;
    }
}
